"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request_1 = __importStar(require("./request"));
const metadata_1 = require("../model/metadata");
const base64_1 = require("../utils/base64");
const axios = require('axios'); // eslint-disable-line
class Metadata {
    constructor(configuration) {
        this.url = `${configuration.values().coordinationEndpoint}/config`;
        this.request = new request_1.default(configuration.identify);
    }
    set(keyValue) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = `${this.url}/base64:${(0, base64_1.encode)(keyValue.key)}`;
            const data = (0, base64_1.encode)(keyValue.value);
            console.log(url);
            console.log(data);
            const result = yield this.request.send((token) => axios.put(url, data, {
                headers: {
                    Authorization: `Bearer ${token}`,
                },
            }));
            return result === 'Ok';
        });
    }
    get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = `${this.url}/base64:${(0, base64_1.encode)(key.key)}`;
            const result = yield this.request.send((token) => axios.get(url, {
                headers: (0, request_1.headers)(token),
            }));
            return (0, metadata_1.mapToKeyValue)(result);
        });
    }
    delete(key) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = `${this.url}/base64:${(0, base64_1.encode)(key.key)}`;
            const result = yield this.request.send((token) => axios.delete(url, {
                headers: (0, request_1.headers)(token),
            }));
            return result === 'Ok';
        });
    }
    getPage(directory, nextKey) {
        return __awaiter(this, void 0, void 0, function* () {
            let url = this.url;
            if (directory) {
                url = `${this.url}/base64:${(0, base64_1.encode)(directory.key)}`;
            }
            let params = {};
            if (nextKey) {
                params = {
                    form: `${this.url}base64:${(0, base64_1.encode)(nextKey.key)}`,
                };
            }
            const result = yield this.request.send((token) => axios.get(url, {
                headers: (0, request_1.headers)(token),
                params: params,
            }));
            return (0, metadata_1.mapToKeyValuePage)(result);
        });
    }
    getAllPages(directory, nextKey) {
        return __awaiter(this, void 0, void 0, function* () {
            const pages = [];
            let forNextKey = nextKey;
            while (true) {
                const pageResult = yield this.getPage(directory, forNextKey);
                const page = pageResult;
                pages.concat(page.keyValuePairs);
                if (!page.nextKey) {
                    forNextKey = page.nextKey;
                }
                else {
                    return pages;
                }
            }
        });
    }
}
exports.default = Metadata;
